/*
  190715 Fujigaya2
*/

#include "AudioPlay.h"

/*    
    AudioPlay();
    ~AudioPlay();
    void snd_init();
    void snd_stop(int nm);
    void snd_play(int nm,const char *filename,float v);
    void Sound_Loop(byte m);
*/

//　＋ＢＧＭは、snd_play(0,”/pno-cs.mp3″,0.3f);
//　　ＳＥは、snd_play(1,”/0004.mp3″,SoundVolume);という形で発声させる。

//========================================================================
//
//sound_system
//
//2018/10/9 T.K Add
//

AudioPlay::AudioPlay()
{
  //Serial.println("AudioPlay_constructor");
}

AudioPlay::~AudioPlay()
{
  //Serial.println("AudioPlay_destructor");
}

void AudioPlay::snd_init()
{
  //Serial.println("AudioPlay_snd_init");
  WiFi.mode(WIFI_OFF); 
  //delay(1000);    
  SPIFFS.begin();
  //各種ポインタをNullにして、初期化
  for(int i = 0; i < ALL_FILE_NUM;i++)
  {
    //mp3[i]=nullptr;
    wav[i]=nullptr;
    stub[i]=nullptr;
    file[i]=nullptr;
  }
  //if(Sound_mode==2)
  //  return;
  //out = new AudioOutputI2S(0, 1); // Output to builtInDAC
  out = new AudioOutputI2S(); // Output to I2S
  out->SetOutputModeMono(true);
  out->stop();
  mixer = new AudioOutputMixer(32, out);
  //delay(300);  
}

void AudioPlay::snd_stop(int nm)
{
  //Serial.println("AudioPlay_snd_stop");
  //if(Sound_mode==2)
  //  return;
  if (stub[nm]!=nullptr)
  {
    stub[nm]->SetGain(0);
  }//発声を止めさせるだけなら、これだけで良い。
  //if (mp3[nm]!=nullptr)
  if (wav[nm]!=nullptr)
  {
    //mp3[nm]->stop();
    //delete mp3[nm];
    //mp3[nm]=nullptr;
    wav[nm]->stop();
    delete wav[nm];
    wav[nm]=nullptr;
    //id3[nm]->close();
    //delete id3[nm];
  }//2018/10/27修正 リークが蓄積すると落ちる
  if (stub[nm]!=nullptr)
  {
    stub[nm]->stop();
    delete stub[nm];
    stub[nm]=nullptr;
  }  
}

//=====================================
//Play
void AudioPlay::snd_play(int nm,const char *filename,float v)
{
  //Serial.println("AudioPlay_snd_play");
  //if(Sound_mode==2)
  //  return;
  snd_stop(nm);
  if(file[nm]!=nullptr)
    delete file[nm];//2018/10/28修正 リークが蓄積すると落ちる
  file[nm] = new AudioFileSourceSPIFFS(filename);
  //id3[nm] = new AudioFileSourceID3(file[nm]);
  stub[nm] = mixer->NewInput();
  stub[nm]->SetGain(v);
  //mp3[nm] = new AudioGeneratorMP3();
  //mp3[nm]->begin(id3[nm], stub[nm]);
  wav[nm] = new AudioGeneratorWAV();
  wav[nm]->begin(file[nm], stub[nm]);
}

//========================================================================
//10/11 T.K Add
void AudioPlay::Sound_Loop(byte m)
{
  //Serial.println("AudioPlay_Sound_Loop");
  //and Speed adjustment m=0:Add BGM Rekick
  //Sound Loop & Rekick
  //if(Sound_mode==0&&mp3[0]!=0&&mp3[0]->isRunning())
  for (int i= 0;i < ALL_FILE_NUM;i++)
  {
    //if(mp3[i]!=0&&mp3[i]->isRunning())
    if(wav[i]!=0&&wav[i]->isRunning())
    {
      //if (!mp3[i]->loop())
      if (!wav[i]->loop())
      {
        snd_stop(i);
        out->stop();
        Serial.print("Stop= ");
        Serial.println(i);
      }
    }
  }
}

int AudioPlay::get_filenum()
{
  return ALL_FILE_NUM;
}


//==========================================================================
//現状のtoggle_chを返す。
int AudioPlay::get_toggle_ch()
{
  return current_ch;
}

//==========================================================================
//ch_numを返す0～7の場合は同じ番号を返し、-1の場合は3～7を順繰りに返す。
//使い方としては0,1,2は固定チャンネル、3,4,5,6,7は順繰りのチャンネルを考えている。
int AudioPlay::set_toggle_ch(int nm)
{
  if(nm != -1)
  {
    return nm; 
  }
  else
  {
    current_ch++;
    if(current_ch == ALL_FILE_NUM)
    {
      current_ch = FIXED_FILE_NUM;
    }
    return current_ch;
  }
  return -1;
}
