/*
  AudioPlay
  190715 Fujigaya2
*/

#ifndef _AUDIOPLAY_H
#define _AUDIOPLAY_H

#include <Arduino.h>
#ifdef ESP32
  #include <WiFi.h>
  #include "SPIFFS.h"
#else
  #include <ESP8266WiFi.h>
#endif

#include "AudioFileSourceSPIFFS.h"
//#include "AudioFileSourceID3.h"
//#include "AudioGeneratorMP3.h"
#include "AudioOutputI2S.h"
#include "AudioOutputMixer.h"
#include "AudioGeneratorWAV.h"

#define ALL_FILE_NUM 8
#define FIXED_FILE_NUM 3
//参考　http://www.team-rh.com/tetris-with-m5stack-t-k-kai-free-download-page-2/

class AudioPlay
{
  public:
    AudioPlay();
    ~AudioPlay();
    void snd_init();
    void snd_stop(int nm);
    void snd_play(int nm,const char *filename,float v);
    void Sound_Loop(byte m);
    int get_filenum();
    int get_toggle_ch();
    int set_toggle_ch(int nm);

  private:
    AudioGeneratorWAV *wav[ALL_FILE_NUM];
    //AudioGeneratorMP3 *mp3[ALL_FILE_NUM];
    AudioFileSourceSPIFFS *file[ALL_FILE_NUM];
    AudioOutputI2S *out;
    //AudioFileSourceID3 *id3[ALL_FILE_NUM];
    AudioOutputMixer *mixer;
    AudioOutputMixerStub *stub[ALL_FILE_NUM];
    byte Sound_mode=1;//0:SE/BGM全再生 1:BGMミュート 2:ミュート
    unsigned long FrameTime = 0;
    float SoundVolume = 0.2f;    
    int current_ch = FIXED_FILE_NUM;//トグルでチャンネルを回すときの番号　0～2を固定チャンネルとして、3～7をイベントチャンネルとしようか？
    
/*    
    virtual bool open(const char *filename) { (void)filename; return false; };
    virtual uint32_t read(void *data, uint32_t len) { (void)data; (void)len; return 0; };
    virtual uint32_t readNonBlock(void *data, uint32_t len) { return read(data, len); }; 
    virtual bool seek(int32_t pos, int dir) { (void)pos; (void)dir; return false; };
    virtual bool close() { return false; };
    virtual bool isOpen() { return false; };
    virtual uint32_t getSize() { return 0; };
    virtual uint32_t getPos() { return 0; };
    virtual bool loop() { return true; };

  public:
    virtual bool RegisterMetadataCB(AudioStatus::metadataCBFn fn, void *data) { return cb.RegisterMetadataCB(fn, data); }
    virtual bool RegisterStatusCB(AudioStatus::statusCBFn fn, void *data) { return cb.RegisterStatusCB(fn, data); }

  protected:
    AudioStatus cb;
*/    
};

#endif
