//https://github.com/mrrwa/NmraDcc/tree/master/examples/NmraDccMultiFunctionDecoder_1から改造
//MP3V5_DL110を一部マージ
//190615 fujigaya2

#include "AudioPlay.h"

#include "motor_func.h"
#include "motor_ctrl.h"
#include "AudioPlay.h"
#include "AudioPlay.h"
#include <NmraDcc.h>

AudioPlay *APlay;

#define This_Decoder_Address 3

//Debug用
//#define DCC_DEBUG

//////////
//CV num
//////////
#define CV_FUNCSTATE 200

//////////
//Task Schedule
//////////
unsigned long gPreviousL1 = 0;
unsigned long gPreviousL2 = 0;
unsigned long gPreviousL3 = 0;
unsigned long gPreviousL4 = 0;

unsigned long gPreviousL5 = 0; //161117 fujigaya2
unsigned long gPreviousL6 = 0; //170419 fujigaya2
unsigned long gIntervalRail = 1000;

//////////
//Speed関連
//////////
//モータ制御関連の変数
uint16_t gSpeedCmd = 0;
uint16_t gSpeedCmd_vvvf = 0;
uint16_t gSpeedCmd_rail = 0;//fujigaya2
uint8_t gPwmDirv = 128;
uint8_t gCV29_Vstart = 0;
uint8_t gCV29Direction = 0;
uint8_t gDecoderMode = 0; //2018/01/01　nagoden


//////////
//Function 部分変数
//////////
//MP3 Control
uint8_t gCV58_MP3_Vol = 28;
uint8_t gCVMP3Table[29] = {0};

//////////
//Function用変数
//////////
uint8_t gFuncBits[29] = {0};
uint8_t gCV110_MP3_F0 = 0;
uint8_t gCV49_SoundNotch = 1;//0:ノッチオフあり,1:ノッチオフなし

uint8_t gF0_FCONTROL = 0; //ヘッド・テールのライトライト制御　2018/01/01　nagoden
uint8_t gF0_BCONTROL = 0; //ヘッド・テールのライトライト制御　2018/01/01　nagoden

//アンプボリューム調整
uint8_t gAmpVol_Up;                                //K1.2 Ajust by MECY 2017/02/12
uint8_t gAmpVol_Down;                              //K1.2 Ajust by MECY 2017/02/12

//////////
//Function用関数
//////////
void ControlRoomLight(void);
void ControlHeadLight(void);
void FunctionInit(void);

//////////
//CV
//////////
uint8_t gCV2_Vstart = 20;
uint8_t gCV3_AccRatio = 16;
uint8_t gCV4_DecRatio = 16;
uint8_t gCV5_VMAX = 255;
uint8_t gCV30_DecoderMode = 0;  //デコーダモード　0：モータ　1:モータ制御なし　2018/01/01　nagoden

uint8_t gCV54_BEMFcoefficient = 64; // 0-127 step / Reajust by MECY 2017/10/08
uint8_t gCV55_PI_P = 18;            // Reajust by MECY 2017/10/08
uint8_t gCV56_PI_I = 96;
uint8_t gCV57_BEMF_CutOff = 0;  // 0でBEMF Off 1でBEMF On

//////////
//Pin setting
//////////
#define PIN_LIGHT  21
//#define PIN_HEADF1  16
//#define PIN_HEADF2  17
#define PIN_HEADF1  18
#define PIN_HEADF2  19
#define PIN_HEADD1  32
#define PIN_HEADD2  33
#define PIN_DCC_IN 4

struct CVPair
{
  uint16_t  CV;
  uint8_t   Value;
};

CVPair FactoryDefaultCVs [] =
{
	// The CV Below defines the Short DCC Address
  {CV_MULTIFUNCTION_PRIMARY_ADDRESS, This_Decoder_Address},

  // These two CVs define the Long DCC Address
  {CV_MULTIFUNCTION_EXTENDED_ADDRESS_MSB, 0},
  {CV_MULTIFUNCTION_EXTENDED_ADDRESS_LSB, This_Decoder_Address},

// ONLY uncomment 1 CV_29_CONFIG line below as approprate
//  {CV_29_CONFIG,                                      0}, // Short Address 14 Speed Steps
  {CV_29_CONFIG,                       CV29_F0_LOCATION}, // Short Address 28/128 Speed Steps
//  {CV_29_CONFIG, CV29_EXT_ADDRESSING | CV29_F0_LOCATION}, // Long  Address 28/128 Speed Steps  
};

NmraDcc  Dcc ;

uint8_t FactoryDefaultCVIndex = 0;

// Uncomment this line below to force resetting the CVs back to Factory Defaults
// FactoryDefaultCVIndex = sizeof(FactoryDefaultCVs)/sizeof(CVPair);

void notifyCVResetFactoryDefault()
{
  // Make FactoryDefaultCVIndex non-zero and equal to num CV's to be reset 
  // to flag to the loop() function that a reset to Factory Defaults needs to be done
  FactoryDefaultCVIndex = sizeof(FactoryDefaultCVs)/sizeof(CVPair);
};

// Uncomment the #define below to print all Speed Packets
#define NOTIFY_DCC_SPEED
#ifdef  NOTIFY_DCC_SPEED
void notifyDccSpeed( uint16_t Addr, DCC_ADDR_TYPE AddrType, uint8_t Speed, DCC_DIRECTION Dir, DCC_SPEED_STEPS SpeedSteps )
{
  uint16_t aSpeedRef = 0;
  
  //速度値の正規化(255を100%とする処理)
  if( Speed >= 1)
  {
    aSpeedRef = ((Speed - 1) * 255) / SpeedSteps;
  }
  else
  {
    //緊急停止信号受信時の処理 //Nagoden comment 2016/06/11
#ifdef DCC_DEBUG
    Serial.println("***** Emagency STOP **** ");
#endif
    aSpeedRef = 0;
  }

  //VVVF用
  gSpeedCmd_vvvf = aSpeedRef; 
  //リミッタ //Nagoden Adjust1 2016/06/11
  //if(aSpeedRef > gCV5_VMAX)
  //{
    //aSpeedRef =gCV5_VMAX;
    aSpeedRef = aSpeedRef * gCV5_VMAX / 255; 
  //}
  
  
  gSpeedCmd = aSpeedRef;
  gPwmDirv = Dir;
  if ( gCV29Direction > 0)
  {
     if ( Dir == DCC_DIR_FWD)
     {
          gPwmDirv = 128;
     }
    else
    {
          gPwmDirv = 0;     
    }     
  }
  else
  {
     if ( Dir == DCC_DIR_FWD)
     {
          gPwmDirv = 0;
     }
    else
    {
         gPwmDirv =128;     
    }     
  }

#if defined(DCC_DEBUG)
  Serial.print("notifyDccSpeed: Addr: ");
  Serial.print(Addr,DEC);
  Serial.print( (AddrType == DCC_ADDR_SHORT) ? "-S" : "-L" );
  Serial.print(" Speed: ");
  Serial.print(Speed,DEC);
  Serial.print(" Steps: ");
  Serial.print(SpeedSteps,DEC);
  Serial.print(" Dir: ");
  Serial.println( (Dir == DCC_DIR_FWD) ? "Forward" : "Reverse" );
#endif

};
#endif

// Uncomment the #define below to print all Function Packets
#define NOTIFY_DCC_FUNC
#ifdef  NOTIFY_DCC_FUNC
void notifyDccFunc(uint16_t Addr, DCC_ADDR_TYPE AddrType, FN_GROUP FuncGrp, uint8_t FuncState)
{
  switch(FuncGrp)
  {
    case FN_0_4:
//      Function F00
         if  ((FuncState & FN_BIT_00) == 16)
         {
            if (gFuncBits[0] == 0)
            {
              gFuncBits[0] = 1;
            Dcc.setCV(CV_FUNCSTATE + 0, 1);
            }
         }    
         else
         {
            if (gFuncBits[0] == 1) 
            {
              gFuncBits[0] = 0;
          Dcc.setCV(CV_FUNCSTATE + 0, 0);

            }
         }
             
//      Function F01
         if  ((FuncState & FN_BIT_01) == 1){
            if (gFuncBits[1] == 0)
            {
              gFuncBits[1] = 1;
            Dcc.setCV(CV_FUNCSTATE + 1, 1);
            }
         }    
         else
         {
            if (gFuncBits[1] == 1) 
            {
              gFuncBits[1] = 0;
          Dcc.setCV(CV_FUNCSTATE + 1, 0);

            }
         }
//      Function F02
         if  ((FuncState & FN_BIT_02) == 2)
     {
          PlayMP3_P(2);
         }    
         else 
    {
      PlayMP3_N(2);
         }
//      Function F03
         if  ((FuncState & FN_BIT_03) == 4)  
         {
      /* CV49=2の時はMP3を再生しない(手動ノッチオフ) */
//      if( gCV49_SoundNotch != 2)
      if( gCV49_SoundNotch == 1)
      {
            PlayMP3_P(3);
      }
      else
      {
        gFuncBits[3] = 1;
      }         
         }    
         else
         {
      /* CV49=2の時はMP3を再生しない(手動ノッチオフ) */
      if( gCV49_SoundNotch != 2)
      {
        PlayMP3_N(3);
      }
      else
      {
        gFuncBits[3] = 0;
      }         
         }
//      Function F04
         if ((FuncState & FN_BIT_04) == 8)
         {
          PlayMP3_P(4);
                gFuncBits[4] = 1;  //F4 bit ctr Add by MECY 2017/10/07
         }    
         else
         {
          PlayMP3_N(4);
                gFuncBits[4] = 0;  //F4 bit ctr Add by MECY 2017/10/07
         }
      break;
    case FN_5_8:
//      Function F05    
         if  ((FuncState & FN_BIT_05) == 1)
         {
            if (gCV110_MP3_F0 == 1)  //2018/01/01 nagodden
            {
              gF0_FCONTROL = 1;
            }
            else
            {
               PlayMP3_P(5);
            }  
         }    
         else
         {
            if (gCV110_MP3_F0 == 1)  //2018/01/01 nagodden
            {
              gF0_FCONTROL = 0;
            }
            else
            {
              PlayMP3_N(5);
            }
          } 

//      Function F06    
         if  ((FuncState & FN_BIT_06) == 2) 
         {
            if (gCV110_MP3_F0 == 1)  //2018/01/01 nagodden
            {
              gF0_BCONTROL = 1;
            }
            else
            {
               PlayMP3_P(6);
            }
         }       
         else
         {
            if (gCV110_MP3_F0 == 1)  //2018/01/01 nagodden
            {
              gF0_BCONTROL = 0;
            }
            else
            {
              PlayMP3_N(6);
            }
         } 
//      Function F07    
         if  ((FuncState & FN_BIT_07) == 4) 
         {
            PlayMP3_P(7);
         }    
         else 
         {
            PlayMP3_N(7);
         }
//      Function F08    
         if  ((FuncState & FN_BIT_08) == 8)
         {
            PlayMP3_P(8);
         }    
         else
         {
            PlayMP3_N(8);
         }

      break;
    case FN_9_12:
//      Function F09    
         if  ((FuncState & FN_BIT_09) == 1) 
         {
            PlayMP3_P(9);
         }    
         else
         {
            PlayMP3_N(9);

         }
//      Function F10    
         if  ((FuncState & FN_BIT_10) == 2) 
         {
            PlayMP3_P(10);
         }    
         else 
         {
            PlayMP3_N(10);

         }
//      Function F11    
         if  ((FuncState & FN_BIT_11) == 4) 
         {
              PlayMP3_P(11);
         }    
         else 
         {
              PlayMP3_N(11);
         }

//      Function F12    
         if  ((FuncState & FN_BIT_12) == 8) 
         {
            PlayMP3_P(12);
         }    
         else 
         {
            PlayMP3_N(12);
         }

      break;

    case FN_13_20:
//      Function F13
         if  ((FuncState & FN_BIT_13) == 1) 
         {
            PlayMP3_P(13);
         }    
         else 
         {
            PlayMP3_N(13);

         }
//      Function F14    
         if  ((FuncState & FN_BIT_14) == 2) 
         {
            PlayMP3_P(14);
         }    
         else 
    {
            PlayMP3_N(14);

         }
//      Function F15    
         if  ((FuncState & FN_BIT_15) == 4) 
         {
            PlayMP3_P(15);
         }    
         else 
         {
            PlayMP3_N(15);
         }

//      Function F16    
         if  ((FuncState & FN_BIT_16) == 8) 
         {
            PlayMP3_P(16);
         }    
         else 
         {
            PlayMP3_N(16);
         }
//      Function F17    
         if  ((FuncState & FN_BIT_17) == 16) 
         {
            PlayMP3_P(17);
         }    
         else 
         {
            PlayMP3_N(17);
         }
//      Function F18    
         if  ((FuncState & FN_BIT_18) == 32) 
         {
            PlayMP3_P(18);
         }    
         else 
         {
            PlayMP3_N(18);
         }
//      Function F19    
         if  ((FuncState & FN_BIT_19) == 64) 
         {
            PlayMP3_P(19);
         }    
         else 
         {
            PlayMP3_N(19);
         }

 //      Function F20    
        if  ((FuncState & FN_BIT_20) == 128) 
        {
            PlayMP3_P(20);
         }    
         else 
         {
            PlayMP3_N(20);
         }
      break;
      
    case FN_21_28:
//      Function F21    

         if  ((FuncState & FN_BIT_21) == 1) 
         {
            PlayMP3_P(21);
         }    
         else 
         {
            PlayMP3_N(21);
         }
//      Function F22    
         if  ((FuncState & FN_BIT_22) == 2) 
         {
            PlayMP3_P(22);
         }    
         else 
         {
            PlayMP3_N(22);
         }
//      Function F23    
         if  ((FuncState & FN_BIT_23) == 4) 
         {
            PlayMP3_P(23);
         }    
         else 
         {
            PlayMP3_N(23);

         }
//      Function F24    
         if  ((FuncState & FN_BIT_24) == 8) 
         {
            PlayMP3_P(24);
         }    
         else 
         {
            PlayMP3_N(24);
         }
//      Function F25    
         if  ((FuncState & FN_BIT_25) == 16) 
         {
            PlayMP3_P(25);
         }    
         else 
         {
            PlayMP3_N(25);
         }
//      Function F26    
         if  ((FuncState & FN_BIT_26) == 32) 
         {
            PlayMP3_P(26);
         }    
         else 
         {
            PlayMP3_N(26);
         }
//      Function F27    
         if  ((FuncState & FN_BIT_27) == 64) 
         {
            PlayMP3_P(27);
         }    
         else 
         {
            PlayMP3_N(27);
         }
 //      Function F28    
         if  ((FuncState & FN_BIT_28) == 128) 
         {
            PlayMP3_P(28);
         }    
         else
         {
            PlayMP3_N(28);
         }
     break;
  }
  



}
#endif

// Uncomment the #define below to print all DCC Packets
#define NOTIFY_DCC_MSG
#ifdef  NOTIFY_DCC_MSG
void notifyDccMsg( DCC_MSG * Msg)
{
#if defined(DCC_DEBUG)
  Serial.print("notifyDccMsg: ") ;
  for(uint8_t i = 0; i < Msg->Size; i++)
  {
    Serial.print(Msg->Data[i], HEX);
    Serial.write(' ');
  }
  Serial.println();
#endif
}
#endif

// This function is called by the NmraDcc library when a DCC ACK needs to be sent
// Calling this function should cause an increased 60ma current drain on the power supply for 6ms to ACK a CV Read 

const int DccAckPin = 15 ;

void notifyCVAck(void)
{
#if defined(DCC_DEBUG)
  Serial.println("notifyCVAck") ;
#endif
  
  digitalWrite( DccAckPin, HIGH );
  delay( 8 );  
  digitalWrite( DccAckPin, LOW );
}

void setup()
{
  Serial.begin(115200);
  Serial.println("NMRA Dcc Multifunction Decoder Demo 1");

  // Configure the DCC CV Programing ACK pin for an output
  pinMode( DccAckPin, OUTPUT );
  digitalWrite( DccAckPin, LOW );

  /* アンプボリューム調整 */
  //uint8_t aAmpVol = Dcc.getCV( CV_AMP_Vol);
  uint8_t aAmpVol = 0;
  if( aAmpVol > 21)
  {
    gAmpVol_Up = aAmpVol - 21;
    gAmpVol_Down = 0;
    
  }
  else if( aAmpVol < 21)
  {
    gAmpVol_Up = 0;
    gAmpVol_Down = 21 - aAmpVol;
  }
  else
  {
    //何もしない(Default, 12dB)
    gAmpVol_Up = 0;
    gAmpVol_Down = 0;
  }
  
  // Setup which External Interrupt, the Pin it's associated with that we're using and enable the Pull-Up 
  //Dcc.pin(0, 2, 0);
  Dcc.pin(PIN_DCC_IN, 0);
  
  // Call the main DCC Init function to enable the DCC Receiver
  //Dcc.init( MAN_ID_DIY, 10, CV29_ACCESSORY_DECODER | CV29_OUTPUT_ADDRESS_MODE, 0 );

  Dcc.init( MAN_ID_DIY, 10, FLAGS_MY_ADDRESS_ONLY, 0 );

  //FunctionInit
  FunctionInit();

  //MotorInit
  MOTOR_Init();
  MOTOR_SetCV(2, gCV2_Vstart);
  MOTOR_SetCV(3, gCV3_AccRatio);
  MOTOR_SetCV(4, gCV4_DecRatio);
  MOTOR_SetCV(5, gCV5_VMAX);
  MOTOR_SetCV(54, gCV54_BEMFcoefficient);        //Nagoden Adjust1 2016/06/02
//  VVVF_SetCV(3, gCV3_AccRatio);
//  VVVF_SetCV(4, gCV4_DecRatio);
//  VVVF_SetCV(47, gCV47_SoundSwitch);        // 160917 fujigaya2
//  VVVF_SetCV(48, gCV48_SoundState);        // 160917 fujigaya2
//  VVVF_SetCV(49, gCV49_SoundNotch);        //161010 Yaasan
//  VVVF_SetCV(50, gCV50_SoundVolume);       //161108 fujigaya2
  MOTOR_SetCV(55, gCV55_PI_P);        // MECY Adjust1 2016/04/09
  MOTOR_SetCV(56, gCV56_PI_I);        // MECY Adjust1 2016/04/09
  MOTOR_SetCV(57, gCV57_BEMF_CutOff);  

  //Reset task
  gPreviousL1 = millis();
  gPreviousL2 = millis();
  gPreviousL3 = millis();
  gPreviousL4 = millis();
  gPreviousL5 = millis();

  //AudioInit
  APlay = new AudioPlay();
  APlay->snd_init();

  // Uncomment to force CV Reset to Factory Defaults
  notifyCVResetFactoryDefault();
#if defined(ESP32)
  Serial.println("ESP32");
#endif
}

void loop()
{
  // You MUST call the NmraDcc.process() method frequently from the Arduino loop() function for correct library operation
  
  Dcc.process();
  
  if( FactoryDefaultCVIndex && Dcc.isSetCVReady())
  {
    FactoryDefaultCVIndex--; // Decrement first as initially it is the size of the array 
    Dcc.setCV( FactoryDefaultCVs[FactoryDefaultCVIndex].CV, FactoryDefaultCVs[FactoryDefaultCVIndex].Value);
  }

  //BEMF
  if( (millis() - gPreviousL1) >= 10)
  {
    if (gCV30_DecoderMode != 1 )  //2018/01/01 Nagoden
    {
      //Speed detection
      MOTOR_Sensor();
    }
    //Reset task
    gPreviousL1 = millis();

  } 

  //MotorControl
  if( (millis() - gPreviousL3) >= 100)
  {
    if (gCV30_DecoderMode != 1 ) //2018/01/01 Nagoden
    {
      //Motor drive control
      MOTOR_Main(gSpeedCmd, gPwmDirv);
    }
    //Reset task
    gPreviousL3 = millis();   
  }

  
  if( (millis() - gPreviousL4) >= 250)
  { 
    ControlRoomLight();
    ControlHeadLight();
    //アンプボリューム調整
    if(gAmpVol_Up > 0)
    {
      Play_VolUp();
      
      gAmpVol_Up--;
    }
    
    
    if( gAmpVol_Down > 0)
    {
      Play_VolDown();
      
      gAmpVol_Down--;
    }
    
    
    //Reset task
    gPreviousL4 = millis();
  }

  //SoundLoop
  APlay->Sound_Loop(0);
    
}

void FunctionInit(void)
{
  //ファンクションの割り当てピン初期化
  pinMode(PIN_LIGHT, OUTPUT);
  digitalWrite(PIN_LIGHT, 0);
  
  pinMode(PIN_HEADF1, OUTPUT);
  digitalWrite(PIN_HEADF1, 0);
  
  pinMode(PIN_HEADF2, OUTPUT);
  digitalWrite(PIN_HEADF2, 0);  
  
  pinMode(PIN_HEADD1, OUTPUT);
  digitalWrite(PIN_HEADD1, 0);
  
  pinMode(PIN_HEADD2, OUTPUT);
  digitalWrite(PIN_HEADD2, 0);
}

void ControlRoomLight(void)
{
  
  if(gFuncBits[1] == 0)
  {
    digitalWrite(PIN_LIGHT, 0);
    
  }
  else
  {
    digitalWrite(PIN_LIGHT, 1);
  }
  
}

void ControlHeadLight(void)
{
  
  if(gFuncBits[0] == 0)
  {
    digitalWrite(PIN_HEADF1, 0);
    digitalWrite(PIN_HEADF2, 0);  
    digitalWrite(PIN_HEADD1, 0);
    digitalWrite(PIN_HEADD2, 0);
    pinMode(PIN_HEADF1, INPUT);
    pinMode(PIN_HEADF2, INPUT);
    pinMode(PIN_HEADD1, INPUT);
    pinMode(PIN_HEADD2, INPUT);

    return;
  }
  if( gPwmDirv == 0)
  {
    //FWD
    if (gF0_FCONTROL == 0  && gF0_BCONTROL ==0)
    {
      pinMode(PIN_HEADF1, OUTPUT);
      pinMode(PIN_HEADF2, OUTPUT);
      pinMode(PIN_HEADD1, OUTPUT);
      pinMode(PIN_HEADD2, OUTPUT);
      digitalWrite(PIN_HEADF1, 1);
      digitalWrite(PIN_HEADF2, 0);
      digitalWrite(PIN_HEADD1, 0);
      digitalWrite(PIN_HEADD2, 1);  
      return;
    } 
    if (gF0_FCONTROL == 1  && gF0_BCONTROL ==1)
    {
      digitalWrite(PIN_HEADF1, 0);
      digitalWrite(PIN_HEADF2, 0);
      digitalWrite(PIN_HEADD1, 0);
      digitalWrite(PIN_HEADD2, 0); 
      pinMode(PIN_HEADF1, INPUT);
      pinMode(PIN_HEADF2, INPUT);
      pinMode(PIN_HEADD1, INPUT);
      pinMode(PIN_HEADD2, INPUT);
      return;
    } 
    if ( gF0_FCONTROL == 1)
    {
      pinMode(PIN_HEADD1, OUTPUT);
      pinMode(PIN_HEADD2, OUTPUT);
      digitalWrite(PIN_HEADF1, 0);
      digitalWrite(PIN_HEADF2, 0);
      digitalWrite(PIN_HEADD1, 0);
      digitalWrite(PIN_HEADD2, 1); 
      pinMode(PIN_HEADF1, INPUT);
      pinMode(PIN_HEADF2, INPUT);
    }
    if ( gF0_BCONTROL == 1)
    {
      pinMode(PIN_HEADF1, OUTPUT);
      pinMode(PIN_HEADF2, OUTPUT);
      digitalWrite(PIN_HEADF1, 1);
      digitalWrite(PIN_HEADF2, 0);
      digitalWrite(PIN_HEADD1, 0);
      digitalWrite(PIN_HEADD2, 0);  
      pinMode(PIN_HEADD1, INPUT);
      pinMode(PIN_HEADD2, INPUT);
    }
  }
  else
  {
    //REV
    if (gF0_FCONTROL == 0  && gF0_BCONTROL ==0)
    {
      pinMode(PIN_HEADF1, OUTPUT);
      pinMode(PIN_HEADF2, OUTPUT);
      pinMode(PIN_HEADD1, OUTPUT);
      pinMode(PIN_HEADD2, OUTPUT);
      digitalWrite(PIN_HEADF1, 0);
      digitalWrite(PIN_HEADF2, 1);  
      digitalWrite(PIN_HEADD1, 1);
      digitalWrite(PIN_HEADD2, 0);
      return;
    }
    
    if ( gF0_FCONTROL == 1 && gF0_BCONTROL == 1)
    {
      digitalWrite(PIN_HEADF1, 0);
      digitalWrite(PIN_HEADF2, 0);
      digitalWrite(PIN_HEADD1, 0);
      digitalWrite(PIN_HEADD2, 0);
      pinMode(PIN_HEADF1, INPUT);
      pinMode(PIN_HEADF2, INPUT);
      pinMode(PIN_HEADD1, INPUT);
      pinMode(PIN_HEADD2, INPUT);
  
      return;
     }

    if ( gF0_FCONTROL == 1)
    {
      pinMode(PIN_HEADD1, OUTPUT);
      pinMode(PIN_HEADD2, OUTPUT);
      digitalWrite(PIN_HEADF1, 0);
      digitalWrite(PIN_HEADF2, 0);
      digitalWrite(PIN_HEADD1, 1);
      digitalWrite(PIN_HEADD2, 0); 
      pinMode(PIN_HEADF1, INPUT);
      pinMode(PIN_HEADF2, INPUT);
    }
    
    if ( gF0_BCONTROL == 1)
    {
      pinMode(PIN_HEADF1, OUTPUT);
      pinMode(PIN_HEADF2, OUTPUT);
      digitalWrite(PIN_HEADF1, 0);
      digitalWrite(PIN_HEADF2, 1);
      digitalWrite(PIN_HEADD1, 0);
      digitalWrite(PIN_HEADD2, 0);  
      pinMode(PIN_HEADD1, INPUT);
      pinMode(PIN_HEADD2, INPUT);
    }  
  }
}

void PlayMP3_P(uint8_t inMusicNo)
{
  PlayMP3_PosiEdge( inMusicNo, &gFuncBits[inMusicNo], gCVMP3Table[inMusicNo]);
//  Dcc.setCV(CV_FUNCSTATE + inMusicNo, 1);
}

void PlayMP3_N(uint8_t inMusicNo)
{
  PlayMP3_NegaEdge( inMusicNo, &gFuncBits[inMusicNo], gCVMP3Table[inMusicNo]);
//  Dcc.setCV(CV_FUNCSTATE + inMusicNo, 0);
}

void Play_VolUp(void)
{
//  digitalWrite(PIN_AMPUP, 0);
//  delay(33);
//  digitalWrite(PIN_AMPUP, 1);
}

void Play_VolDown(void)
{
//  digitalWrite(PIN_AMPDOWN, 0);
//  delay(33);
//  digitalWrite(PIN_AMPDOWN, 1);
}

void PlayMP3_PosiEdge(uint8_t inMusicNo, uint8_t *iopFnBit, uint8_t inModeCV)
{

  /* 0: ON/OFFのエッジで再生 */
  /* 1: ONレベルで再生(リピート無し) */
  /* 2: ONレベルで再生(リピート有り) */
  char temp_buf[100] = "";
  sprintf(temp_buf,"/%04d.wav",inMusicNo);
  Serial.println(temp_buf);  
  
  if ( *iopFnBit == 0)
  {
    *iopFnBit = 1;
    //mp3_set_volume (gCV58_MP3_Vol);
    //delay (WAIT_VOLMP3);
    //mp3_play (inMusicNo);
    //APlay->snd_play(-1,"/0003.wav",0.8f);
    int ch = APlay->set_toggle_ch(-1);
    APlay->snd_play(ch,temp_buf,0.8f);
    if (inModeCV == 2)
    {
      //delay (WAIT_VOLMP3);
      //mp3_single_loop (true);
    }
  }
  else
  {
    /* 何もしない */
  }
}

void PlayMP3_NegaEdge(uint8_t inMusicNo, uint8_t *iopFnBit, uint8_t inModeCV)
{
  char temp_buf[100] = "";
  sprintf(temp_buf,"/%04d.wav",inMusicNo);
  Serial.println(temp_buf);  

  if ( *iopFnBit == 1)
  {
    *iopFnBit = 0;
    
    if ((inModeCV == 2) || (inModeCV == 1))
    {
      /* 1: ONレベルで再生(リピート無し) */
      /* 2: ONレベルで再生(リピート有り) */
      //mp3_single_loop (false);
      //APlay->snd_play(-1,"/0003.wav",0.8f);
      int ch = APlay->set_toggle_ch(-1);
      APlay->snd_play(ch,temp_buf,0.8f);
      //delay (WAIT_VOLMP3);
      //mp3_stop () ;
      APlay->snd_stop(ch);
      //delay (WAIT_VOLMP3);
    }
    else if (inModeCV == 0)
    {
      /* 0: ON/OFFのエッジで再生 */
      //mp3_set_volume (gCV58_MP3_Vol);
      //delay (WAIT_VOLMP3);
      //mp3_play (inMusicNo) ;
      //APlay->snd_play(-1,"/0003.wav",0.8f);
      int ch = APlay->set_toggle_ch(-1);
      APlay->snd_play(ch,temp_buf,0.8f);
      //delay (WAIT_VOLMP3);
    }
    else
    {
      //mp3_stop() ;
      //ここは今バグるはず！
      APlay->snd_stop(0);
    }
  }
  else
  {
    //何もしない
  }
}
